//+------------------------------------------------------------------+
//|                                        Open Price Percentage.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "aye.bdg@gmail.com-(modified to become open-percentage)-thanks bro Aye" 

#property indicator_chart_window
//---- input parameters
extern string      TimeFrameInfo = "H4:240, DAILY: 1440, WEEKLY: 10080, MONTHLY: 43200";
extern int         Per           = 1440;
extern int         PeriodsToPlot = 1;
extern string      PercentInfo   = "Separate percent by comma";
extern string      PercentList   = "0.25,0.50,0.75,1.0,1.25,1.50"; 
extern color       OpenColor     = Chocolate;
extern color       PositiveColor = Green;
extern color       NegativeColor = Maroon;
extern int         LineStyle     = 0;
extern int         LineWidth     = 1;

double Percents[3]={0.382,0.618,1.00};//dummy
#define PREFIX "open_percentage_"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int idx, last_idx, count_idx;
   string str;   
//---- indicators
  //parsing percent on PercentList
  for(;;)
  {
    idx = StringFind(PercentList, ",", last_idx);
    if (idx >= 0) 
    {
      str = StringTrimRight(StringTrimLeft(StringSubstr(PercentList, last_idx, idx-last_idx)));
      //Print("count_idx :", count_idx, " idx ", idx, " lidx ", last_idx, " str ",str);
      last_idx = idx+1;
    }else
    {
      str = StringTrimRight(StringTrimLeft(StringSubstr(PercentList, last_idx, StringLen(PercentList)-last_idx)));     
      //Print("end.... str ",str);
    }
    count_idx +=1; 
    ArrayResize(Percents, count_idx);
    Percents[count_idx-1] = StrToDouble(str);
    
    if (idx < 0) break;

  }
  
  Print("count_idx :", count_idx, " Percent Size ", ArraySize(Percents));
  
  //for (int i=0; i<ArraySize(Percents); i++)
    //Print ("Percents ", i, " : ", Percents[i]);
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringSubstr(name,0,StringLen(PREFIX)) == PREFIX) ObjectDelete(name); 
      WindowRedraw();
   }     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,k,limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   int bar_per, bar0;
   double o, c;
   datetime t1, t2;
   datetime dt_open1, dt_open2;
   double lvl, lvl382, lvl618, lvl100;   
   string stemp;

   if (Period()>Per) return(0);
   bar0 = iBarShift(NULL, Per, Time[0]);
   bar_per = bar0+PeriodsToPlot;
   
   for (i=bar_per-1,k=0; i>=bar0; i--,k++)
   {
      
      o = iOpen(NULL, Per, i);
      dt_open1  = iTime(NULL, Per, i);
      dt_open2  = iTime(NULL, Per, i-1);
      t1 = Time[iBarShift(NULL, 0, dt_open1)];
      //Print(iBarShift(NULL, 0, dt_open1), " ", TimeToStr(iBarShift(NULL, 0, dt_open1)));
      if (i==bar0)
        t2 = Time[0]+10*Period()*60;//dt_open1 + (Period() * Per/Period()) * 60;
      else
        t2 = Time[iBarShift(NULL, 0, dt_open2)];
            
      DrawTl(PREFIX+Per+k+ "0%-", t1, o, t2, o, OpenColor, LineStyle, LineWidth, "Gain 0%");
      
      for (j=0; j<ArraySize(Percents); j++)
      {
        lvl = /*NormalizeDouble(*/(Percents[j]/100)*o/*, Digits)*/;
        stemp = DoubleToStr(Percents[j],4);
        DrawTl(PREFIX+Per+k+"+"+stemp , t1, o+lvl,  t2, o+lvl,  PositiveColor, LineStyle, LineWidth, "Gain +"+stemp+"%");
        DrawTl(PREFIX+Per+k+"-"+stemp , t1, o-lvl,  t2, o-lvl,  NegativeColor, LineStyle, LineWidth, "Gain -"+stemp+"%");  
        
            
      }
      
      if (i==bar0)
      {
        drawFib(PREFIX+Per+"+gain%", t2, o+(0.01*o), t2, o, PositiveColor);
        drawFib(PREFIX+Per+"-gain%", t2, o-(0.01*o), t2, o, NegativeColor);
        drawFib(PREFIX+Per+"0gain%", t2, o, t2, o, OpenColor, true);
        Comment((Close[0]-o)/o);  
      }
    
   }
   
   
   
//----
   return(0);
  }
  
void DrawTl(string tlName, datetime t1, double v1, datetime t2, double v2, 
            color tlColor, int style = STYLE_SOLID, int width = 1, string desc="")
{
   if(ObjectFind(tlName) != 0)
   {
      ObjectCreate(
            tlName
            , OBJ_TREND
            , 0
            , t1
            , v1
            , t2
            , v2
            );      
   }else
   {
      ObjectMove(tlName, 0, t1, v1);   
      ObjectMove(tlName, 1, t2, v2);
   }
   ObjectSet(tlName, OBJPROP_COLOR, tlColor);
   ObjectSet(tlName, OBJPROP_RAY, false);
   ObjectSet(tlName, OBJPROP_STYLE, style);
   ObjectSet(tlName, OBJPROP_WIDTH, width);
   ObjectSetText(tlName, desc);
}  

void drawFib(string fibname, datetime t1, double v1, datetime t2, double v2, color clr=Gray, bool onlyonelvl=false)
{
  if(ObjectFind(fibname) != 0)
    ObjectCreate(fibname, OBJ_FIBO, 0, t1, v1, t2, v2);
  else
  {
    ObjectMove(fibname, 0, t1, v1);
    ObjectMove(fibname, 1, t2, v2);
  }
  
  ObjectSet(fibname, OBJPROP_RAY, false);
  ObjectSet(fibname, OBJPROP_COLOR, CLR_NONE);
  ObjectSet(fibname, OBJPROP_LEVELCOLOR, clr);
  ObjectSet(fibname, OBJPROP_LEVELSTYLE, LineStyle);
  
  if (onlyonelvl)
  {    
    ObjectSet(fibname, OBJPROP_FIBOLEVELS, 1);
    ObjectSet(fibname, OBJPROP_FIRSTLEVEL+0, 0);
    ObjectSetFiboDescription(fibname, 0, "0.000%$");
  }
  else
  {
    ObjectSet(fibname, OBJPROP_FIBOLEVELS, ArraySize(Percents));
    for (int i=0; i<  ArraySize(Percents); i++)
    {
      ObjectSet(fibname, OBJPROP_FIRSTLEVEL+i, Percents[i]);
      ObjectSetFiboDescription(fibname, i, DoubleToStr(Percents[i],3) + "%$");
    }
  }

  
}

//+------------------------------------------------------------------+